'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var colors = [];
var getColor = function getColor(i) {
  return colors[i] || (colors[i] = '#' + ('000000' + Math.random().toString(16).slice(2, 8)).slice(-6));
};

var styles = {
  label: {
    textTransform: 'uppercase',
    fontSize: '10px',
    color: '#444',
    fontFamily: 'Arial',
    fontWeight: '600'
  }
};

var SuperficialPanel = function (_React$Component) {
  _inherits(SuperficialPanel, _React$Component);

  function SuperficialPanel() {
    _classCallCheck(this, SuperficialPanel);

    var _this = _possibleConstructorReturn(this, (SuperficialPanel.__proto__ || Object.getPrototypeOf(SuperficialPanel)).call(this));

    _this.forceResize = _this.forceResize.bind(_this);
    _this.state = { min: 200, max: 600, width: 400, looks: {} };
    return _this;
  }

  _createClass(SuperficialPanel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.props.channel.on(_constants.DEFINE_EVENT, function (_ref) {
        var min = _ref.min,
            max = _ref.max,
            looks = _ref.looks;

        _this2.setState({ min: min, max: max, looks: looks });
      });
    }
  }, {
    key: 'getPercent',
    value: function getPercent(n) {
      return (n - this.state.min) / (this.state.max - this.state.min) * 100 + '%';
    }
  }, {
    key: 'forceResize',
    value: function forceResize(_ref2) {
      var target = _ref2.target;

      var width = parseInt(target.value, 10);
      this.props.channel.emit(_constants.RESIZE_EVENT, width);
      this.setState({ width: width });
    }
  }, {
    key: 'styleSection',
    value: function styleSection(key) {
      var _this3 = this;

      var props = expandStyles(this.state.looks[key]);
      return _react2.default.createElement(
        'tbody',
        { key: key, style: styles.label },
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            {
              style: {
                borderBottom: '1px solid #ccc',
                borderTop: '10px solid transparent'
              }
            },
            key
          )
        ),
        Object.keys(props).map(function (prop) {
          return _this3.styleRow(prop, props[prop]);
        })
      );
    }
  }, {
    key: 'styleRow',
    value: function styleRow(prop, value) {
      var _this4 = this;

      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') {
        return _react2.default.createElement(
          'tr',
          { key: prop },
          _react2.default.createElement(
            'td',
            null,
            prop
          ),
          _react2.default.createElement(
            'td',
            null,
            value
          )
        );
      }
      var keys = Object.keys(value).sort(function (a, b) {
        return a - b;
      });
      var min = keys[0];
      var max = keys[keys.length - 1];
      return _react2.default.createElement(
        'tr',
        { key: prop },
        _react2.default.createElement(
          'td',
          null,
          prop
        ),
        _react2.default.createElement(
          'td',
          { style: { position: 'relative' } },
          _react2.default.createElement('div', {
            style: {
              position: 'absolute',
              left: this.getPercent(min),
              right: 100 - parseFloat(this.getPercent(max)) + '%',
              top: '50%',
              marginTop: '-1px',
              height: '2px',
              background: getColor(prop)
            }
          }),
          keys.map(function (key) {
            return _react2.default.createElement('div', {
              key: key,
              title: key + 'px: ' + value[key],
              style: {
                position: 'absolute',
                top: '50%',
                marginTop: '-3px',
                height: '6px',
                width: '6px',
                background: 'black',
                left: _this4.getPercent(key),
                borderRadius: '6px',
                cursor: 'pointer'
              }
            });
          })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var looks = Object.keys(this.state.looks);
      return _react2.default.createElement(
        'div',
        { style: { margin: 10, width: '100%' } },
        _react2.default.createElement(
          'table',
          { style: { width: '100%' } },
          _react2.default.createElement(
            'tbody',
            null,
            _react2.default.createElement(
              'tr',
              null,
              _react2.default.createElement('td', { style: { width: '20%' } }),
              _react2.default.createElement(
                'td',
                { style: { width: '80%' } },
                _react2.default.createElement('input', {
                  type: 'range',
                  style: { width: '100%' },
                  min: this.state.min,
                  max: this.state.max,
                  onChange: this.forceResize,
                  value: this.state.width
                })
              )
            )
          ),
          looks.map(function (look) {
            return _this5.styleSection(look);
          })
        )
      );
    }
  }]);

  return SuperficialPanel;
}(_react2.default.Component);

SuperficialPanel.propTypes = {
  channel: _react2.default.PropTypes.shape({
    emit: _react2.default.PropTypes.func,
    on: _react2.default.PropTypes.func
  })
};

var isNumeric = function isNumeric(s) {
  return !isNaN(parseFloat(s)) && isFinite(s);
};

// Split out grouped breakpoint rules into individual properties
function expandStyles(rules) {
  return Object.keys(rules).reduce(function (o, key) {
    if (isNumeric(key)) {
      return Object.assign.apply(Object, [{}, o].concat(_toConsumableArray(Object.keys(rules[key]).map(function (prop) {
        return _defineProperty({}, prop, Object.assign({}, o[prop], _defineProperty({}, key, rules[key][prop])));
      }))));
    }
    return Object.assign({}, o, _defineProperty({}, key, rules[key]));
  }, {});
}

exports.default = SuperficialPanel;